<?php 
namespace backend\models\searches;

use backend\models\Mt4UserApi;
use common\helpers\ExcelHelper;
use common\helpers\UserAgentHelper;
use Yii;
use yii\data\ArrayDataProvider;
use yii\data\Pagination;
use yii\helpers\Url;
use yii\web\Response;

class Mt4UserSearch extends DataTable
{
    /**
     * @param array $params
     * @return ArrayDataProvider
     */
    public function search($params)
    {
        $this->setAttributes($params);
        // 初始化DataTable查询参数
        $this->initSearchParams();

        $pagination = new Pagination();
        $pagination->setPageSize($this->pageSize);
        $data['pageSize'] = $pagination->getPageSize();
        $data['page'] = $this->page;
        if ($this->orderBy) {
            $data['orderBy'] = $this->orderBy;
        }
        if (!empty($this->search['value']) && trim($this->search['value']) !== '') {
            $data['search'] = trim($this->search['value']);
        }

        if ($this->pageSize > 5000) {
            if (Yii::$app->getRequest()->getIsAjax()) {
                Yii::$app->getResponse()->redirect(Url::current(), UserAgentHelper::isIE() ? 200 : 302);
            } else {
                $this->exportXls($data);
            }
            Yii::$app->end();
        }

        $api = new Mt4UserApi();
        $result = $api->getPagelist($data);
        $models = [];
        if ($result['code'] == 1) {
            $models = (array)$result['data']['dataList'];
            $pagination->totalCount = $result['data']['totalCount'];
        }
        $dataProvider = new ArrayDataProvider([
            'models' => $models,
            'pagination' => $pagination,
            'totalCount' => $pagination->totalCount,
        ]);
        return $dataProvider;
    }

    /**
     * @param array $data
     */
    private function exportXls($data)
    {
        ExcelHelper::init();
        $attachmentName = "MT4账户管理_" . date('Y-m-d') . '.xlsx';
        $header = ['代理商', '账户', '姓名', '用户组', '杠杆', '余额', '注册时间'];
        $source = [];
        $api = new Mt4UserApi();
        $data['pageSize'] = 5000;
        $data['page'] = 1;
        while (true) {
            $result = $api->getPagelist($data);
            if ($result['code'] == 1 && !empty($result['data']['dataList'])) {
                foreach ((array)$result['data']['dataList'] as $key => $row) {
                    $arr = [];
                    $arr[] = $row['IBNAME'];
                    $arr[] = $row['LOGIN'];
                    $arr[] = $row['NAME'];
                    $arr[] = $row['GROUP'];
                    $arr[] = "1:{$row['LEVERAGE']}";
                    $arr[] = $row['BALANCE'];
                    $arr[] = $row['REGDATE'];
                    $source[] = $arr;
                }
            } else {
                break;
            }
            if ($data['page'] * $data['pageSize'] >= $result['data']['totalCount']) {
                break;
            }
            $data['page']++;
        }
        ExcelHelper::output($source, $header, $attachmentName);
    }
}